<?php 
/*
Plugin Name: GRA4 Social Network
Version: 0.0.4.3
Plugin URI: http://gra4.com/groups/profile/98/gra4-webmasters-wordpress
Description: Social networks put plenty of web communities out of commission - anyone can create a group on Facebook, and it's much easier than to build and support whole website. We want to get web-masters back into the game - with GRA4 any WP installation can get it's own full-blown social networking subsystem.
Author: GRA4
Author URI: http://gra4.com
License: GPLv2 or later
*/

/*
HOW TO INSTALL
Please see http://en.wiki.gra4.com/Category:GRA4_for_WordPress

SUPPORT GROUP
http://gra4.com/groups/profile/98/gra4-webmasters-wordpress
*/

error_reporting(0);
ini_set("display_errors", 0);

define('IN_GRA4', true);
include_once('gra4_functions_local.php');
define ('GRA4_VERSION', GRA4GetLocalClientVersion());

class gra4
{
	
	function gra4()
    {
		ob_start(); //GRA4 may send headers out - so we prevent warning
		
		register_activation_hook( __FILE__, array( &$this, 'set_theme_options' ) );
		
		//Activation Hook
		add_action('init', array (&$this,'init_func'));
		
		add_filter('upgrader_pre_install', array (&$this,  'gra4_backup'));
		add_filter('upgrader_post_install', array (&$this, 'gra4_recover'));
		
        if (function_exists ('add_shortcode') )
        {
			add_shortcode('GRA4_CONTENT', array (&$this, 'content_func')); 
			
			add_filter( 'rewrite_rules_array', array (&$this, 'set_seo_friendly_rules'));			

			// admin page
			add_action('admin_menu',  array (&$this, 'admin') );
			add_filter( 'plugin_action_links', array( $this, 'gra4_plugin_action_links'), 10, 2 );


			
			if (strstr($_SERVER['REQUEST_URI'], '/gra4')){
				//GRA4 supplies the dynamic content even for non-logged visitors.
				//Therefore we try to switch off caching for the GRA4 pages
				//WP Super Cache plugin documentation ( http://ocaoimh.ie/wp-super-cache-developers/ ) recommends this way:
				define('DONOTCACHEPAGE', true);
				define('DONOTMINIFY', true);
				//If it does not work, please upgrade the WP Super Cache plugin to the latest version and flush the caches.


//				add_action('widgets_init', array (&$this,'remove_sidebars'), 20);
				
				add_action('wp_print_scripts', array (&$this, 'enqueue_scripts') );		
				add_filter('the_content', array (&$this, 'filter'));
				remove_action('template_redirect', 'redirect_canonical');
				add_filter( 'jetpack_enable_opengraph', '__return_false', 99 );
				add_filter('jetpack_enable_open_graph', '__return_false', 99);
			}
    	}
	}


	function gra4_plugin_action_links( $links, $file ) {
		if ( $file == plugin_basename( dirname(__FILE__).'/gra4.php' ) ) {
			$links[] = '<a href="' . admin_url("options-general.php?page=gra4.php") . '">Settings</a>';
		}

		return $links;		
	}


	// Set default THEME option when the plug-in is activated
	function set_theme_options()
	{
		update_option( 'gra4_version', GRA4_VERSION);
		
		add_option( 'gra4_dom_tree', 'none');
		add_option( 'gra4_dom_node_id', '');
			
		add_option( 'gra4_margin_none', '1');
			
		add_option( 'gra4_set_width', 'none');
		add_option( 'gra4_delta_width', '0');
			
		add_option( 'gra4_set_custom_template', '1');
		
		if( get_option( 'gra4_set_custom_template') == '1')
		{
			$this->update_gra4_template( '1');
		}
		
		add_option( 'gra4_reset_page', '0');
	}

	function admin()
	{		
			add_menu_page( 'GRA4  Settings', 'GRA4  Settings', 8, basename(__FILE__), 
							array (&$this,'admin_option_page'),
							plugin_dir_url( __FILE__ ).'gra4_sm.png');
	}

	function admin_info_page()
	{
		$plugin_dir_path = plugin_dir_path(__FILE__);
		?>
        <div class="wrap">      
        	<h2 style="color:#21759B;">GRA4 Social Network Plugin</h2>
        	<p><?php @readfile( $plugin_dir_path.'admin-text.txt') ?></p>        
        </div>
        <?php
    }

	function saved()	
	{
		?>
        <script type="text/javascript">
			jQuery('#result').html('Changes were saved successfully!').show(1000);
		</script>
        <?php
	}
	
	function admin_option_page()
	{
     	define('IN_GRA4', true);
    	require_once('gra4_functions.php');
		?>
        <div class="wrap">      
        	<h2 style="color:#21759B;">GRA4 Settings</h2><hr />
            <div id="result"
            	style="background:#FF9; border-radius:10px; font-size:14px; padding:5px; display:none;">
        	</div>
		<?php
	  if(!gra4_is_private_ip($_SERVER['REMOTE_ADDR']))
		{
		  ?>
		<div style="background:#FF9; border-radius:10px; font-size:14px; padding:5px;">
			GRA4 is not intended to operate on a local machine.<br />
		</div>
          <?php
		  return;
	  }

	  $GRA4_secret = GRA4GetConfigValue('GRA4_secret');
		
	  if( $GRA4_secret != '' OR strstr( $GRA4_secret, 'TMP') )
	  {
		?>
            <form  id="save_settings" method="post" >
		<?php
		$replace_flag = 0;
		$dom_options = '';
		$dom_node_id = '';
		$margin_option = '';
		$set_width = '';
		$delta_width = '0';
		
		if(count($_POST) > 0)
		{		
			if( $_POST['place']){
				$dom_options = $_POST['place'];
				update_option( 'gra4_dom_tree', $dom_options);
				$replace_flag = 1;
			}
			else
			{
				$dom_options = get_option( 'gra4_dom_tree');
			}
			
			// margin option
			if( $_POST['margin_none'])
			{
				update_option( 'gra4_margin_none', '0');
				$margin_option = 0;
				$replace_flag = 1;
			}
			else
			{
				$margin_option = 1;
				update_option( 'gra4_margin_none', '1');
			}
			// set width option
			if( $_POST['set_width'])
			{
				$set_width = $_POST['set_width'];
				update_option( 'gra4_set_width', $set_width);
				$replace_flag = 1;
			}
			else
			{
				$set_width = get_option( 'gra4_set_width');
			}
			
			// GRA4 custom template
			if( $_POST['set_custom_template'] == 'on' && get_option( 'gra4_set_custom_template') != '1'){
				$custom_template = '1';
				if( !$this->update_gra4_template( $custom_template)){
					$custom_template = get_option( 'gra4_set_custom_template');
				}
					
				if($custom_template == '1'){	
					update_option( 'gra4_set_custom_template', $custom_template);				
					$this->reset_DOM_settings();				
					update_option( 'gra4_reset_page', '1');
				}
				
				$dom_options = get_option( 'gra4_dom_tree');
				$dom_node_id = get_option( 'gra4_dom_node_id');
				$margin_option = get_option( 'gra4_margin_none');
				$set_width = get_option( 'gra4_set_width');
				$delta_width = get_option( 'gra4_delta_width');
			}
			elseif( $_POST['set_custom_template'] == 'on' && get_option( 'gra4_set_custom_template') == '1'){
				$custom_template = '1';
			}
			// GRA4 special positoin
			elseif( get_option( 'gra4_set_custom_template') == '1'){
				$custom_template = '0';
				if( !$this->update_gra4_template( $custom_template)){
				//	$custom_template = get_option( 'gra4_set_custom_template');
				}
					
				if($custom_template == '0'){					
					update_option( 'gra4_set_custom_template', $custom_template);
					update_option( 'gra4_reset_page', '1');					
				}
				
				$dom_options = get_option( 'gra4_dom_tree');
				$dom_node_id = get_option( 'gra4_dom_node_id');
				$margin_option = get_option( 'gra4_margin_none');
				$set_width = get_option( 'gra4_set_width');
				$delta_width = get_option( 'gra4_delta_width');
			}
			else{ 
				$custom_template = '0';
			 $dom_options = get_option( 'gra4_dom_tree');
			 $dom_node_id = get_option( 'gra4_dom_node_id');
			 $margin_option = get_option( 'gra4_margin_none');
			 $set_width = get_option( 'gra4_set_width');
			 $delta_width = get_option( 'gra4_delta_width');
			}
			$this->saved(); // info string
		}
		else
		{
			 $dom_options = get_option( 'gra4_dom_tree');
			 $dom_node_id = get_option( 'gra4_dom_node_id');
			 $margin_option = get_option( 'gra4_margin_none');
			 $set_width = get_option( 'gra4_set_width');
			 $delta_width = get_option( 'gra4_delta_width');
			 
			 $custom_template = get_option( 'gra4_set_custom_template');
		}
		
		
// GRA4 special position (get DOM tree)
	if($custom_template == '0'){
		
		include('vendors/simpledom/simple_html_dom.php');		
		$html = $this->remote_file_get_html( get_home_url().'/gra4/'); //like 'http://mydomen.ru/WP/gra4'
//		$html = $this->file_get_contents_curl( get_home_url().'/gra4/');
		if( $html){
			$ret = $html->getElementById('#gra4_wordpress');
			if( $ret){
				$tree = array();
				$tree[] = $ret->parent();
				$i = 0;
				while( $tree[$i]->tag != 'body'){
					$tree[] = $tree[$i]->parent();
					$i++;
				}
				$tree = array_reverse($tree);   // DOM tree
			}
			else{ //can`t get element #gra4_wordpress
						?>
		<div style="background:#FF9; border-radius:10px; font-size:14px; padding:5px;">
			This page does not contain the GRA4 content.<br />
		</div><br />
        				<?php
				$tree = '';
			}
		}
		else $tree = '';   // Can`t get DOM
		
	}// END $custom_template == '0'
		
		?>
	
<p>
<input id="set_custom_template" name="set_custom_template" type="checkbox" onClick="g4_visualization_submit(this);"
        <?php
		if( $custom_template == 1)
		{
			echo ' checked="checked">';
		}
		else
		{
			echo '>';
		}
		?>
&nbsp;&nbsp;&nbsp;
Use Simplified Visualization.
</input>
 <a onClick="g4_open_test_window('<?php echo get_home_url().'/gra4/?wp_set=simple' ?>'); return false;" href="" title="Opens the front-end of your website in new window." target="_blank">Preview</a>
<script type="text/javascript">
var igGlobalPopup;
function g4_open_test_window(sUrl)
{
	igGlobalPopup = window.open(sUrl,'gra4_test_window','width=1100,height=600,scrollbars=yes');
	igGlobalPopup.focus();
}

function g4_open_test_window2(sUrl)
{
	setTimeout(function(){ g4_open_test_window_assync(sUrl); }, 500);
}

function g4_visualization_submit(id_2_gray)
{
	document.getElementById('save_settings').submit();	
	id_2_gray.disabled = true;
	
}

function g4_change_visualization(bSimple)
{
		var idVisualization = document.getElementById("set_custom_template");
		idVisualization.checked=bSimple; 
		g4_visualization_submit(idVisualization);
		document.getElementById("save_settings").submit(); 
		return false;
}
</script>
<div id="simplified_visualization_block" style="border:solid red 0px;">
<h2>Simplified Visualization</h2>	
<br />Simplified Visualization uses custom GRA4 theme template. This setting works for the most of the themes. 
<a onClick="g4_open_test_window('<?php echo get_home_url().'/gra4/?wp_set=simple' ?>'); return false;" href="" title="Opens the front-end of your website in new window." target="_blank">See how your social network looks</a>. 
<br>If the content of your GRA4 subsystem looks too shifted to the right or to the bottom, or it is obscured by other elements,
try to switch off the sidebars for the GRA4 page. If it does not help (or your custom theme does not have such option), use the 
<a onClick="g4_change_visualization(false); return false;" href="" title="Switch to Extended Visualization">Extended Visualization</a>.
</p>
</div> <?php /* "simplified_visualization_block" end*/?>

<div id="extended_visualization_block" style="border:solid blue 0px;">
	<h2>Extended Visualization</h2>

<p>Extended Visualization uses complicated Javascript-powered DOM positioning. 
<br/>Recommended only if your social content looks shifted, or overlaps with the sidebar.<br />
Some Themes do not provide options to hide sidebars for a particular page, or too narrow to accommodate the GRA4 content.<br />
If in the default position your social content collides with other elements of the page, 
you may want to move the GRA4 block up in the page elements hierarchy, 
change width of the upper elements, or suppress the frame of the element, parent to the social content block.<br />
Unfortunately, there is to universal settings working for every custom theme, so you will have to experiment.
Play with the controls, and don't forget to save options before you 
<a onClick="g4_open_test_window('<?php echo get_home_url().'/gra4/?wp_set=extended' ?>'); return false;" href="" title="Opens the front-end of your website in new window." target="_blank">view the results</a>,
so your changes will take effect. The <a href="#video_tutorial">video tutorial</a> may help,
<br>If you are not satisfied with the results, you can always return to the 
<a onClick="g4_change_visualization(true); return false;" href="" title="Switch to Simplified Visualization">Simplified Visualization</a>.
</p>

<?php
	if( $custom_template == '0'){
?>
<script>
function g4_set_extedned_default(theme_id)
{
	if(theme_id == 'wp10')
	{
		var id_p = document.getElementById('place_main');
		if(id_p)id_p.checked = true;
		var id_w = document.getElementById('set_width_wrapper');
		if(id_w)id_w.checked = true;
		var id_m = document.getElementById('margin_none').checked = true;
	}
	if(theme_id == 'wp11')
	{
		var id_p = document.getElementById('place_main');
		if(id_p)id_p.checked = true;
		var id_w = document.getElementById('set_width_main');
		if(id_w)id_w.checked = true;
		var id_m = document.getElementById('margin_none').checked = true;
	}
	if(theme_id == 'wp12')
	{
		var id_p = document.getElementById('place_gra4');
		if(id_p)id_p.checked = true;
		var id_w = document.getElementById('set_width_gra4');
		if(id_w)id_w.checked = true;
		var id_m = document.getElementById('margin_none').checked = false;
	}
	
	return false;	
}
</script>
Example: set the default values for WordPress standard theme 
[<a onClick="return g4_set_extedned_default('wp10')" href='javascript:void(0);' title="Set the Settings like for the Twenty Ten theme where possible.Block position:'main',Make wider:'wrapper',Parent frame:suppressed"><b>Twenty Ten</b></a>],
[<a onClick="return g4_set_extedned_default('wp11')" href='javascript:void(0);' title="Set the Settings like for the Twenty Eleven theme where possible.Block position:'main',Make wider:'default',Parent frame:suppressed"><b>Twenty Eleven</b></a>], or
[<a onClick="return g4_set_extedned_default('wp12')" href='javascript:void(0);' title="Reset the Settings for default values.Block position:'default',Make wider:'default',Parent frame:not suppressed"><b>reset</b></a>]

<table>
<tr><td style=" font-weight:bold; text-align:center">GRA4 block position</td>
<td style=" font-weight:bold; text-align:center">Make wide</td></tr>
<tr >
<td width="300px" style="border-top:1px solid #21759B; border-bottom:1px solid #21759B;">
		<?php
		$step = '&nbsp;';
		echo '<input name="place" id="place" type="radio" disabled value="body"';
		echo '> '.$step.'BODY</input><br />';
		$step .= '&nbsp;';		
		for( $i=1; $i < count($tree); $i++){
			if( $tree[$i]->id){
				$treeId = ' id='.$tree[$i]->id;
				
				echo "\n".'<input name="place"  id="place_'.$tree[$i]->id.'" type="radio" value="'.$i.'"';
				if( $dom_options == $i){
				 	echo ' checked="checked"';
					$replace_string = $tree[$i]->id;
					update_option( 'gra4_dom_node_id', $replace_string);
				}
				echo '> ';
			 	echo $step.$tree[$i]->tag.$treeId.'</input><br />';
				$step .= '&nbsp;&nbsp;';
			}
		}
		echo '<br /><input name="place" type="radio" id="place_gra4" value="none"';
		if( $dom_options == 'none') 
			echo ' checked="checked" ';
		echo '> '.$step.'GRA4 default position</input><br />';
		
		?>
</td>
<td width="300px" style="border-top:1px solid #21759B; border-bottom:1px solid #21759B;">
		<?php
		$step = '&nbsp;';
		echo '<input id="set_width" name="set_width"  type="radio" disabled value="body"';
		echo '> '.$step.'BODY</input><br />';
		$step .= '&nbsp;';		
		$last_i = 0;		
		for( $i=1; $i < count($tree); $i++){
			if( $tree[$i]->id){
				$treeId = ' id='.$tree[$i]->id;
				
				echo "\n".'<input name="set_width" id="set_width_'.$tree[$i]->id.'" type="radio" value="'.$i.'"';
				if( $set_width == $i){
				 	echo ' checked="checked"';
					$set_width = $i;
				}
				echo '> ';
			 	echo $step.$tree[$i]->tag.$treeId.'</input><br />';
				$step .= '&nbsp;&nbsp;';
				$last_i = $i;				
			}
		}
		$last_i++;
		echo '<br /><input name="set_width" type="radio" id="set_width_gra4" value="'.$last_i.'"';
		if( $set_width == $last_i OR $set_width == 'none' ) echo ' checked="checked" ';
		echo '> '.$step.'GRA4 block</input><br />';
		
		// get DELTA
		if($dom_options == 'none'){
			$delta_width = $last_i - $set_width;
		}
		else{
			$delta_width = $dom_options - $set_width;
		}
		update_option('gra4_delta_width', $delta_width);
		?>

</td>
</tr>
</table>        

        <br />
		<span title='To maximize space, available for the social content, you also may want to suppress the frame of the parent element of the GRA4 block. '>
		<input type="checkbox" id="margin_none" name="margin_none" 
        <?php
		if($margin_option == 1)
		{
			echo '>';
		}
		else
		{
			echo ' checked="checked">';
		}
		?>
        
        	&nbsp;      Suppress parent frame
        </input>
		</span>
        
        <?php
		$html->clear(); // clean data
		unset($html);
		
		if($replace_flag == 1){
			$this->set_place($replace_string, $margin_option, $delta_width);
			update_option( 'gra4_reset_page', '1');
		}
		?>
        
<?php
	}	// END if( $custom_template == '0')
	else{
?>		
<?php
	}
?>        
        <br />
   			<input type="hidden" name="action" value="update" />
   			<input type="hidden" name="replace_string" value="<?php echo $replace_string?>" />
            <br />
   			<input type="submit" onClick="g4_open_test_window('about:blank');" name="Submit" value="<?php _e('Save and view the results') ?>" />(Preview of the front-end of your social network will be shown in a pop-up window)
 
		</form>
</div> <?php /* "extended_visualization_block" end*/?> 
<?php
		if( $custom_template == '0'){ 
?>
<a name="video_tutorial"></a>
<h3>Extended Visualization Video Tutorial</h3>
<iframe width="480" height="360" src="http://www.youtube.com/embed/ORBR8ql_UPw?rel=0" frameborder="0" allowfullscreen></iframe>

<?php
	}	
?>
<script>
function gra4_change_visualization()
{
	var idVisualization = document.getElementById("set_custom_template");
	var idSimplifiedBlock = document.getElementById("simplified_visualization_block");
	var idExtendedBlock = document.getElementById("extended_visualization_block");
	if(idVisualization && idSimplifiedBlock && idExtendedBlock)
	{
		if(idVisualization.checked == true)	//show simplified
		{
			idExtendedBlock.style.display = 'none';
			idSimplifiedBlock.style.display = 'inline';		
		}
		else //show extended
		{
			idExtendedBlock.style.display = 'inline';
			idSimplifiedBlock.style.display = 'none';		
		}
	}
	else //we don't have something!
	{
		alert("Error !\n" + idVisualization + "\n" + idSimplifiedBlock + "\n" + idExtendedBlock);	
	}
}
gra4_change_visualization();
</script>


<hr />
<h2>Useful links</h2>
<p>If you done with the configuration, you may want to <a title="<?php echo get_home_url().'/gra4'; ?>" href="<?php echo get_home_url().'/gra4'; ?>">visit your social network</a> and</p>
<p>

- Edit your Profile (<a title="Read more at GRA4 Wiki" href="http://en.wiki.gra4.com/Profile">wiki</a>)<br />
- Change your Avatar (<a title="Read more at GRA4 Wiki" href="http://en.wiki.gra4.com/Avatar">wiki</a>)<br />
- Visit your Groups, configure the group of your website, it will help you to promote and manage your social community.<br />
- Take a look at the 
<a title="<?php echo get_home_url().'/gra4'; ?>/groups/profile/98/gra4-webmasters-wordpress/" href="<?php echo get_home_url().'/gra4'; ?>/groups/profile/98/gra4-webmasters-wordpress/" >
GRA4 for WordPress</a>
and 
<a title="<?php echo get_home_url().'/gra4'; ?>/groups/profile/94/gra4-webmasters/" href="<?php echo get_home_url().'/gra4'; ?>/groups/profile/94/gra4-webmasters/" >
GRA4 Webmasters</a> groups.</p>
<!--
<p>See <a href="<?php echo admin_url().'admin.php?page=admin_info_page' ?>">Info</a> page for additional information.</p>
-->
<?php
//going to view results 
	if(isset($_POST['Submit'])) 
	{
		echo('<script>g4_open_test_window("'.get_home_url().'/gra4/?wp_set=submit");</script>');	
	}
	else
	{
//print_r($_POST);		
	}
	

?>        
       <?php
	  }// END registered in GRA4
	  
	  
	  else
	  {
		if(!function_exists('mb_strlen'))
		{
			?>
			<div style="background: #F93; border-radius:10px; font-size:14px; padding:5px;">
    	    	<center>The <b>mbstring</b> extension library is not available.
					<br />Please adjust your PHP configuration.</center>        
			</div>            
			<?php
		}
		else
		{
			$flag_is_page = $this->is_gra4_page();
			$flag_is_permalink = $this->check_permalink();
			if( !$flag_is_page OR !$flag_is_permalink ){  // page OR permalink not exist
				if( $_POST['Install_page']){ 
					if( !$flag_is_page){ // We create page atomatically
			  			if( $this->create_gra4_page()){
							$flag_is_page = true;
						?>                    
		<div style="background:#FF9; border-radius:10px; font-size:14px; padding:5px;">
			The page <b>GRA4 Social Network</b> has been created successfully.<br />
		</div>
    	                <?php
						}
						else{
						?>
		<div style="background:#FF9; border-radius:10px; font-size:14px; padding:5px;">
			An error occured during the automatic page creation. Please try to create the page manually.
            <br />
			See <a href="http://wiki.gra4.com/">GRA4 Wiki</a> for more information.
		</div>
    	                <?php
						}
					}  // !$this->is_gra4_page()
					
					if( !$this->check_permalink() ){
						$this->create_permalink(); // We create permalink atomatically
						$flag_is_permalink = true;
						?>
		<div style="background:#FF9; border-radius:10px; font-size:14px; padding:5px;">
			The permalink settings have been adjusted successfully.<br />
		</div>
        				<?php
					}

					if( $flag_is_permalink AND $flag_is_page){ // All right
						?>
		<div style="background:#FF9; border-radius:10px; font-size:14px; padding:5px;">
			Your System is ready for the GRA4 Social Network operation. <br />
			To complete the installation process, please <a href="<?php echo get_home_url().'/gra4'; ?>" target="_blank">visit your GRA4 subsystem</a>. 
			After the installation is complete, feel free to <a title="click to reload the page" href="javascript:window.location = &quot;<?php echo get_home_url().'/wp-admin/admin.php?page=gra4.php'; ?>&quot;">reload this page</a> to access the GRA4 Settings.
		</div>
        				<?php
					}
					
				}
				else{		// GRA4 page or permalink not found
					if( !$flag_is_permalink AND !$flag_is_page){ // GRA4 page and permalink not found
						?>
		<div style="background:#FF9; border-radius:10px; font-size:14px; padding:5px;">
			To operate properly the GRA4 Social Network requires 			
			the GRA4 page to exist, and the Permalink Settings not to be set to 'default'. <br/>
			These changes are not going to affect current functionality of your System. <br/>
		</div><br />
        				<?php
					}
					elseif(!$flag_is_permalink){ // only GRA4 permalink not found
						?>
		<div style="background:#FF9; border-radius:10px; font-size:14px; padding:5px;">
            To operate properly the GRA4 Social Network requires the Permalink Settings not to be set to 'default'.<br />
            This change is not going to affect current functionality of your System. <br/>
		</div><br />
        				<?php
					}
					elseif(!$flag_is_page){  // only GRA4 page not found
						?>
		<div style="background:#FF9; border-radius:10px; font-size:14px; padding:5px;">
			To operate properly the GRA4 Social Network requires the GRA4 page to exist.<br />
			This change is not going to affect current functionality of your System. <br />
		</div><br />
        				<?php
					}
					?>
    	        	<form method="post" name="page_install">
   						<input type="hidden" name="action" value="update" />
   						<input type="submit" name="Install_page" value="<?php _e('Adjust the Settings automatically') ?>" />
					</form>
					<br />
					<?php
				}

        	} // END if( !$flag_is_page OR !$flag_is_permalink)
			else{	 // All right
		  		?>
		<div style="background:#FF9; border-radius:10px; font-size:14px; padding:5px;">
			Your System is ready for the GRA4 Social Network operation. <br />
			Please <a href="<?php echo get_home_url().'/gra4'; ?>" target="_blank">visit your GRA4 subsystem</a>
            to complete the installation.<br />
            After the installation is complete, feel free to <a title="click to reload the page" href="javascript:window.location = &quot;<?php echo get_home_url().'/wp-admin/admin.php?page=gra4.php'; ?>&quot;">reload this page</a> to access the GRA4 Settings.
		</div>
          		<?php
			}
		  
		}
	  }// END dont registered in GRA4
	  
		// div class="wrap"?>
        </div>
        <?php

 	}

	function is_gra4_page(){
		$pages = get_pages();
		$is_page = 0;
		foreach ( $pages as $page ) {
			if( $page->post_name == 'gra4' ){
				$is_page = 1;
			}
  		}
		if( $is_page == 0)
			return false; 	// page not found
		else
			return true;	// page exist
	}
	
	function create_gra4_page(){
			$new_gra4_post = array(
   				'post_title' => 'GRA4 Social Network',
				'post_name' => 'gra4',
   				'post_content' => '[GRA4_CONTENT]',
   				'post_status' => 'publish',
				'post_type' => 'page',
				'comment_status' => 'closed',
			);  
			if( ($gra4_post_id = wp_insert_post( $new_gra4_post )) != '0')
				return true;
			else
				return false;				
	}

	function check_permalink(){
		global $wp_rewrite;
		$permalink_structure = get_option('permalink_structure');
		if( $permalink_structure)
			return true;
		else
			return false;
	}
	
	function create_permalink(){
		global $wp_rewrite;
		$permalink_structure = '/%postname%/';
		$wp_rewrite->set_permalink_structure( $permalink_structure );
		flush_rewrite_rules();
	}


	// Set GRA4 position on the page
	function set_place( $replace_string, $margin = 1, $delta_width = -1)
	{
		$fileName = plugin_dir_path(__FILE__).'js/header.js';
		if ( file_exists($fileName)) {
			$strings = file($fileName);
			$strings[0] = "var place = '$replace_string';\r\n";
			
			if( $margin == 0){
				$strings[1] = "var margin = '0';\r\n";
			}
			else
			{
				$strings[1] = "var margin = '1';\r\n";
			}
			
//			if( $delta_width < 0){
//				$strings[2] = "var set_width = 0;\r\n";
//			}
//			else
			{
				$strings[2] = "var set_width = $delta_width;\r\n";
			}
			
			file_put_contents ($fileName, $strings);		
		}
		else{
    		echo "ERROR: Please make sure file 'header.js' do exist in the plugin 'js' directory.";
		}
	}


	function install_gra4_template()
	{
		$path_template = plugin_dir_path(__FILE__).'page-gra4.php';
		if( file_exists( $path_template)){
//			$current_theme = WP_CONTENT_DIR . get_raw_theme_root() . '/' . get_stylesheet();
			$current_theme = get_stylesheet_directory();
			$path_to_copy = $current_theme.'/page-gra4.php';
			if( copy($path_template, $path_to_copy)){
				return true;
			}
			else{
				//echo 'Can not install the GRA4 Custom Theme Template at ' . $path_template;
				return false;
			}
		}
	}
		
	function delete_gra4_template()
	{
//	$current_theme = WP_CONTENT_DIR . get_raw_theme_root() . '/' . get_stylesheet();
		$current_theme = get_stylesheet_directory();
		$path_to_delete = $current_theme.'/page-gra4.php';
		if(file_exists($path_to_delete))
		{
			if( unlink( $path_to_delete)){
				return true;
			}
			else{
				echo 'Can not uninstall the GRA4 Custom Theme Template at ' . $path_to_delete;
				return false;
			}
		}		
	}
		
	function update_gra4_template( $set_gra4_template)
	{
		if( $set_gra4_template == '1')// template ON
			return $this->install_gra4_template();
		elseif($set_gra4_template == '0')	// template OFF
			return $this->delete_gra4_template();
	}

	function reset_DOM_settings()
	{
		update_option( 'gra4_dom_tree', 'none');
		update_option( 'gra4_dom_node_id', '');			
		update_option( 'gra4_margin_none', '1');			
		update_option( 'gra4_set_width', 'none');
		update_option( 'gra4_delta_width', '0');
		
		$from = plugin_dir_path(__FILE__).'js/header.js_';
		$to = plugin_dir_path(__FILE__).'js/header.js';
	    if ( is_file($from) && is_file($to)) {
	        return copy($from, $to);
	    }
		else	return false;
	}

	
	function get_pageid()
	{
		global $wpdb;
		return $wpdb->get_var("SELECT ID FROM $wpdb->posts WHERE post_content LIKE '%[GRA4_CONTENT]%' AND post_status = 'publish' AND post_type = 'page'");
	}

	//Shortcode Hook
	function content_func($atts) 
	{
     	define('IN_GRA4', true);
		require_once('gra4_functions.php');	
	  if( !gra4_is_private_ip($_SERVER['REMOTE_ADDR'])) {
		  ?>
			<div style="background:#FF9; border-radius:10px; font-size:14px; padding:5px;">
				GRA4 is not intended to operate on a local machine.<br />
			</div>
          <?php
		  return;
		}
		
		if(!function_exists('mb_strlen'))
		{
			?>
			<div style="background: #F93; border-radius:10px; font-size:14px; padding:5px;">
    	    	<center>The <b>sbstring</b> extension library is not available.
					<br />Please adjust your PHP configuration.</center>        
			</div>            
			<?php
			return;
		}
		
		
    	require_once('gra4_functions.php');

//To give a hint to the people who do not read README files =)
	    if(mb_strpos($_SERVER['REQUEST_URI'],'/gra4') === false)
	    {
		    return("FATAL ERROR: Can't process the URL ! Permalink of this page is not set to 'gra4'? Permalink Settings are set to 'Default'? ");
    	}
//first let's figure out if it's request for CSS

		$strShortSelf = str_replace(mb_strrchr($_SERVER['PHP_SELF'], '/'), '', $_SERVER['PHP_SELF']);

		$aCssNames = explode(',', $aGRA4GlobalConfig['include_css']);


		for ($i = 0; $i < count($aCssNames); $i++) 
		{
			
	    	if ( trim($_SERVER['REQUEST_URI'] , '/') == trim($strShortSelf . '/gra4' . $aCssNames[$i],'/') ) 
			{

	        	$strFileName = dirname(__FILE__) . $aCssNames[$i]; //see gra4_config.php
				

				if (file_exists($strFileName)) {
		        	$strFileContent = file_get_contents($strFileName);

					ob_clean();

			        header("Content-Type:	text/css;charset=UTF-8 \r\n");
				// Tell the user agent to cache this stylesheet for an hour
					$age = 3600;
					header( 'Expires: '.gmdate( 'D, d M Y H:i:s', time()+ $age ) . ' GMT' );
					header( 'Last-Modified: ' . gmdate( 'D, d M Y H:i:s', @filemtime( $strFileName ) ) . ' GMT' );
					header( 'Cache-Control: public, max-age='.$age.', must-revalidate, post-check=0, pre-check=0' );
					header( 'Pragma: public' );
			        exit($strFileContent); //we done!
				}
				else
				{
				    echo "The file $filename does not exist";
				}

			}

		//WORDPRESS SPECIFIC: we have to add '/' to file names, that's how SEO-friendly URLs are created in WordPress

		//Tag must look like <link  rel="stylesheet" href="http://SomeServer.com/wordpress/gra4/css/custom.css/" type="text/css" />

		//If we have '...custom.css', not '...custom.css/', it will cause redirect, and stylesheet file will never get cached.

//			$aCssNames[$i] = $aCssNames[$i] . '/'; //so we fix it in array

		}

		$aGRA4GlobalConfig['include_css'] = implode(',',$aCssNames); //and put it back, already with '/'

		//ok, if we here - we've got real content
		$permalink = get_permalink( $this->get_pageid()); //like 'http://server.com/wordpress/gra4/'
		$link = trim(str_replace(array(site_url(), 'index.php/'), '', $permalink), '/'); //like 'gra4'.

	if($link != 'gra4') {
		$content = '';
	}
	else {
		$bFrameNeeded = true;
   	$content = GRA4FetchRemoteContent($bFrameNeeded);
		if($bFrameNeeded === false) {
			ob_clean();
			exit($content);
		}
	}

//We do it to use default template, otherwise everything will be shifter right, and blink.
// so we display it hidden, and show only when custom.css is loaded.
//REDO! when we switch to custom template.
//Note: '.entry-header,.entry-title' here is butt-ugly, 
//  but otherwise it will blick "GRA4" into user eyes... looks like 24th frame =)
//	<div style="display:block; overflow:auto;">

		$alarm = '';
		if( get_option( 'gra4_reset_page') == '1')
		{
			update_option( 'gra4_reset_page', '0');
			$alarm = '
<div  style="position:fixed; text-align1:center;	padding:10px; font-size:12px; color:#FFF; background:#F00; border-radius:10px; margin-top:100px; z-index:99999; top:10px; left:45%; font-weight1:bold;">
Visualization settings have been changed. <br/>
Please wait while fresh copy of this page loads from the server.<br/>
If page is not loaded, <a title="click to reload the page" href="javascript:window.location.reload(true);">click here to forcefully reload the page</a> .
</div>
<script>window.location.reload(true);</script>
			';
		}

	$start = '
	<style type="text/css">#gra4_wordpress, .entry-header, .entry-title {display:none;}</style>
		<div id="gra4_wordpress"  >';
	$end = '</div>';

	if($link != 'gra4') {
	
	if($link == '')
	{
		$link = 'empty';
	}
	
			$p_alarm = '
<div  style="text-align:center;	padding:10px; font-size:12px; background:#FC3; border-radius:10px;  z-index:99999;">
The permalink of page is <strong>'.$link.'</strong> . Please set it to <strong>gra4</strong>
</div>
			';
		$content = $start.$p_alarm.$end;
	}
	else {
		$content = $start.$content.$alarm.$end;
	}

		return $content;
	}//END content_func
	

	function set_seo_friendly_rules($args)
	{

		$new = array();

		$permalink = get_permalink( $this->get_pageid()); //like 'http://server.com/wordpress/gra4/'

		$link = trim(str_replace(array(site_url(), 'index.php/'), '', $permalink), '/'); //like 'gra4'. 

		if($link !== '1gra4')
		{

//TODO - add error message ?

		}

		$new['(gra4)(/[-/0-9a-zA-Z]+)?/(.*)$'] = 'index.php?pagename=$matches[1]&page=$matches[2]'; //using constant

		return $new + $args;
	}


	function filter($content = '') {
		remove_all_filters('the_content');
		add_filter('the_content', array (&$this, 'filter'));
		
		if ( '' == $content || !strstr($content, '[GRA4_CONTENT]') ) { ob_flush();return $content; }
		return do_shortcode( '[GRA4_CONTENT]' );
	}


	function register_scripts() {
		wp_register_script(
		    'gra4_functions', //идентификатор
			plugin_dir_url(__FILE__).'js/functions.js',
		    array('jquery'), //зависимости
		    null, //версия
		    false //выполняем в header
//		    true //выполняем в body
		);	 
		wp_register_script(
		    'gra4_script', //идентификатор
			plugin_dir_url(__FILE__).'js/header.js',
		    array('jquery'), //зависимости
		    null, //версия
		    false //выполняем в header
//		    true //выполняем в body
		);	 
	}

	function enqueue_scripts(){
	  if (!is_admin()):
	    wp_enqueue_script('gra4_functions');
	    wp_enqueue_script('gra4_script');
	  endif; //!is_admin
	}


	function init_func($atts) 
	{
		// UPDATE 
		if( get_option('gra4_version') != GRA4_VERSION){
			
			add_option( 'gra4_dom_tree', 'none');
			add_option( 'gra4_dom_node_id', '');
			add_option( 'gra4_margin_none', '1');
			add_option( 'gra4_set_width', 'none');
			add_option( 'gra4_delta_width', '0');
			add_option( 'gra4_reset_page', '0');
			
			if( !get_option( 'gra4_set_custom_template')){
				add_option( 'gra4_set_custom_template', '0');
				update_option( 'gra4_version', GRA4_VERSION);
				$gra4_dom_node_id = get_option( 'gra4_dom_node_id');
				$margin_option = get_option( 'gra4_margin_none');
				$delta_width = get_option( 'gra4_delta_width');
			
				$this->set_place( $gra4_dom_node_id, $margin_option, $delta_width);			
			}
		} // end UPDATE
		
		
	// flush_rules() if our rules are not yet included
		$this->register_scripts();

		$rules = get_option( 'rewrite_rules' );

	//comment line bellow if you want to force flush

		if ( ! isset( $rules['(gra4)(/[-/0-9a-zA-Z]+)?/(.*)$'] ) ) //don't have to do it every time
		{
			global $wp_rewrite;
		   	$wp_rewrite->flush_rules();
		}
	}

	// copy file pre/post update plugin
	function gra4_copy($file, $source, $dest)
	{
	    // Make destination directory
	    if (!is_dir($dest)) {
	        mkdir($dest);
	    }		
	    // Simple copy for a file
	    if (is_file($source.$file)) {
	        return copy($source.$file, $dest.$file);
	    }	 
	    return true;
	}
	
	function gra4_backup($atts)
	{
		$upload_dir = wp_upload_dir(); 
       	$to = $upload_dir['path'].'/gra4_backup/';
		
        $from = dirname(__FILE__).'/css/';
		$file = 'custom.css';
	  	if( file_exists($from.$file)){
		    $this->gra4_copy($file, $from, $to);
		}
				
	    $from = dirname(__FILE__)."/";
		$file = 'gra4.cfg';
	    $this->gra4_copy($file, $from, $to);
		
	    $from = dirname(__FILE__)."/js/";
		$file = 'header.js';
	    $this->gra4_copy($file, $from, $to);
	}
	
	function gra4_recover($atts)
	{
		$upload_dir = wp_upload_dir(); 
        $from = $upload_dir['path'].'/gra4_backup/';
		
        $to = dirname(__FILE__)."/css/";
		$file = 'custom.css';
	  	if( file_exists($from.$file)){
        	$this->gra4_copy($file, $from, $to);
			unlink($from.$file);
	  	}
			
        $to = dirname(__FILE__)."/";
		$file = 'gra4.cfg';
        $this->gra4_copy($file, $from, $to);
		unlink($from.$file);

        $to = dirname(__FILE__)."/js/";
		$file = 'header.js';
        $this->gra4_copy($file, $from, $to);
		unlink($from.$file);
			
        if (is_dir($from)) {
        	rmdir($from);
		}
	}


// additional DOM function
	function remote_file_get_html($url, $use_include_path = false, $context=null, $offset = -1, $maxLen=-1, $lowercase = true, $forceTagsClosed=true, $target_charset = DEFAULT_TARGET_CHARSET, $stripRN=true, $defaultBRText=DEFAULT_BR_TEXT, $defaultSpanText=DEFAULT_SPAN_TEXT)
	{
	    $dom = new simple_html_dom(null, $lowercase, $forceTagsClosed, $target_charset, $stripRN, $defaultBRText, $defaultSpanText);
	
//		if( ini_get( 'allow_url_fopen') != 'off')
//		    $contents = file_get_contents($url, $use_include_path, $context, $offset);
//		else
			$contents = $this->file_get_contents_curl($url);
	
	    if (empty($contents) || strlen($contents) > MAX_FILE_SIZE)
	    {
	        return false;
	    }
		
	    $dom->load($contents, $lowercase, $stripRN);
	    return $dom;
	}

	function file_get_contents_curl($url) {
		if( !($ch = curl_init($url))){
			echo "FATAL ERROR:  cUrl are not allowed in your system. GRA4 Does now know how to talk to the server...  =( ";
			return '';
		}
		
		$options = array(
        	CURLOPT_RETURNTRANSFER => true, // return data
	        CURLOPT_HEADER => false, //not return headers			
        	CURLINFO_HEADER_OUT => false,
        	CURLOPT_CONNECTTIMEOUT => 0, 		//indefinately
        	CURLOPT_TIMEOUT => 60, 				//in seconds
//	        CURLOPT_FOLLOWLOCATION => true, // follow redirects
//			CURLOPT_MUTE => true,
		);

		curl_setopt_array($ch, $options);
		
		$data = curl_exec($ch);
	    if ($data === false) {
	        $strError = "cURL failed. Please try to reload this page. If the problem persists - check your PHP settings.";
	        $strError .= "\n<br />" . curl_error($ch);
	        $strError .= "\n<br />Current Maximum Upload Size is " . ini_get('upload_max_filesize');
	        $strError .= "\n<br />Current Maximum POST Size is " . ini_get('post_max_size');
			echo $strError;
	        return '';
	    }
		
		curl_close($ch);
		
//		return '';
		return $data;
	}


	
}// END class Gra4

$gra4 = new Gra4();

?>